--- old/usr/src/test/zfs-tests/cmd/randfree_file/randfree_file.c	Mon Jan  7 12:59:12 2019
+++ new/usr/src/test/zfs-tests/cmd/randfree_file/randfree_file.c	Mon Jan  7 12:59:12 2019
@@ -28,6 +28,10 @@
  * Copyright (c) 2012 by Delphix. All rights reserved.
  */
 
+/*
+ * Copyright (c) 2018, Joyent, Inc.
+ */
+
 #include "../file_common.h"
 
 /*
@@ -84,10 +88,12 @@
 
 	if ((fd = open(filename, O_RDWR | O_CREAT | O_TRUNC, mode)) < 0) {
 		perror("open");
+		free(buf);
 		return (1);
 	}
 	if (write(fd, buf, filesize) < filesize) {
 		perror("write");
+		free(buf);
 		return (1);
 	}
 	fl.l_whence = SEEK_SET;
@@ -95,6 +101,7 @@
 	fl.l_len = off_len;
 	if (fcntl(fd, F_FREESP, &fl) != 0) {
 		perror("fcntl");
+		free(buf);
 		return (1);
 	}
 
